// Chartl32Ctl.cpp : Implementation of the CChartl32Ctrl ActiveX Control class.

#include "stdafx.h"
#include "Chartl32.h"
#include "Chartl32Ctl.h"
#include "Chartl32Ppg.h"

#include "Line1PropPage.h"
#include "Line2PropPage.h"
#include "Line3PropPage.h"
#include "Line4PropPage.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

	


IMPLEMENT_DYNCREATE(CChartl32Ctrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CChartl32Ctrl, COleControl)
	//{{AFX_MSG_MAP(CChartl32Ctrl)
	ON_WM_SHOWWINDOW()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CChartl32Ctrl, COleControl)
	//{{AFX_DISPATCH_MAP(CChartl32Ctrl)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "ChartBackColor", m_chartBackColor, OnChartBackColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "ChartForeColor", m_chartForeColor, OnChartForeColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "Line1Color", m_line1Color, OnLine1ColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "Line2Color", m_line2Color, OnLine2ColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "Line3Color", m_line3Color, OnLine3ColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "Line4Color", m_line4Color, OnLine4ColorChanged, VT_COLOR)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "UpperRangeLine1", m_upperRangeLine1, OnUpperRangeLine1Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "UpperRangeLine2", m_upperRangeLine2, OnUpperRangeLine2Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "UpperRangeLine3", m_upperRangeLine3, OnUpperRangeLine3Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "UpperRangeLine4", m_upperRangeLine4, OnUpperRangeLine4Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "LowerRangeLine1", m_lowerRangeLine1, OnLowerRangeLine1Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "LowerRangeLine2", m_lowerRangeLine2, OnLowerRangeLine2Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "LowerRangeLine3", m_lowerRangeLine3, OnLowerRangeLine3Changed, VT_I4)
	DISP_PROPERTY_NOTIFY(CChartl32Ctrl, "LowerRangeLine4", m_lowerRangeLine4, OnLowerRangeLine4Changed, VT_I4)
	DISP_FUNCTION(CChartl32Ctrl, "Draw", Draw, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CChartl32Ctrl, "PlotLine", PlotLine, VT_EMPTY, VTS_I2 VTS_I4)
	DISP_FUNCTION(CChartl32Ctrl, "ChangeLineColor", ChangeLineColor, VT_EMPTY, VTS_I2 VTS_I4)
	DISP_FUNCTION(CChartl32Ctrl, "ChangeLineRange", ChangeLineRange, VT_EMPTY, VTS_I2 VTS_I4 VTS_I4)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CChartl32Ctrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CChartl32Ctrl, COleControl)
	//{{AFX_EVENT_MAP(CChartl32Ctrl)
	EVENT_STOCK_CLICK()
	EVENT_STOCK_DBLCLICK()
	EVENT_STOCK_KEYDOWN()
	EVENT_STOCK_KEYPRESS()
	EVENT_STOCK_KEYUP()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CChartl32Ctrl, 5)
	PROPPAGEID(CChartl32PropPage::guid)
	PROPPAGEID(CLine1PropPage::guid)
	PROPPAGEID(CLine2PropPage::guid)
	PROPPAGEID(CLine3PropPage::guid)
	PROPPAGEID(CLine4PropPage::guid)
END_PROPPAGEIDS(CChartl32Ctrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CChartl32Ctrl, "CHARTL32.Chartl32Ctrl.1",
	0x6fe073fd, 0xab0f, 0x11d4, 0xaa, 0x39, 0, 0xc0, 0x4f, 0x8a, 0x5e, 0x89)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CChartl32Ctrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DChartl32 =
		{ 0x6fe073fb, 0xab0f, 0x11d4, { 0xaa, 0x39, 0, 0xc0, 0x4f, 0x8a, 0x5e, 0x89 } };
const IID BASED_CODE IID_DChartl32Events =
		{ 0x6fe073fc, 0xab0f, 0x11d4, { 0xaa, 0x39, 0, 0xc0, 0x4f, 0x8a, 0x5e, 0x89 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwChartl32OleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CChartl32Ctrl, IDS_CHARTL32, _dwChartl32OleMisc)


/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl::CChartl32CtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CChartl32Ctrl

BOOL CChartl32Ctrl::CChartl32CtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_CHARTL32,
			IDB_CHARTL32,
			afxRegApartmentThreading,
			_dwChartl32OleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl::CChartl32Ctrl - Constructor

CChartl32Ctrl::CChartl32Ctrl()
{
	InitializeIIDs(&IID_DChartl32, &IID_DChartl32Events);

	// TODO: Initialize your control's instance data here.
	m_pBitmap = new CBitmap;
	m_memDC = new CDC;
	m_sizeChart.cx = -1;
	m_sizeChart.cy = -1;
	m_bDrawVerticle = FALSE;


}


/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl::~CChartl32Ctrl - Destructor

CChartl32Ctrl::~CChartl32Ctrl()
{
	// TODO: Cleanup your control's instance data here.

	delete m_pBitmap;
	delete m_memDC;
	RemoveObjectLine();

}


/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl::OnDraw - Drawing function

void CChartl32Ctrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	

	if ((rcBounds.Width() != m_sizeChart.cx) || (rcBounds.Height() != m_sizeChart.cy)  
			|| (m_colorback != m_chartBackColor) || (m_colorfore != m_chartForeColor)) {

			m_sizeChart.cx = rcBounds.Width();
			m_sizeChart.cy = rcBounds.Height(); 
			m_colorback = m_chartBackColor;
			m_colorfore = m_chartForeColor;
			m_rectChart.CopyRect(&rcBounds); 
			if (m_memDC->GetSafeHdc() != NULL) {
				m_memDC->DeleteDC()  ;
				m_memDC->Detach() ;
				m_pBitmap->DeleteObject(); 
				m_pBitmap->Detach(); 

			}
	}



	if (m_memDC->GetSafeHdc() == NULL) { 
		m_memDC->CreateCompatibleDC(pdc);
		m_pBitmap->CreateCompatibleBitmap(pdc,rcBounds.Width(),rcBounds.Height());
		m_memDC->SelectObject(m_pBitmap); 
		m_memDC->SetBkColor(TranslateColor(m_chartBackColor));
		CBrush  bkBrush(HS_CROSS,TranslateColor(m_chartForeColor));
		m_memDC->FillRect(rcBounds,&bkBrush); 
	}
	
	
	pdc->BitBlt(rcBounds.left,rcBounds.top,rcBounds.Width(),rcBounds.Height() ,m_memDC,0,0,SRCCOPY);     

	
}


/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl::DoPropExchange - Persistence support

void CChartl32Ctrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.



	PX_Color(pPX,"Line1Color",m_line1Color,RGB(0,0,255));
	PX_Color(pPX,"Line2Color",m_line2Color,RGB(255,0,0));
	PX_Color(pPX,"Line3Color",m_line3Color,RGB(0,255,0));
	PX_Color(pPX,"Line4Color",m_line4Color,RGB(255,255,0));
	PX_Color(pPX,"ChartBackColor",m_chartBackColor,RGB(0,0,0));
	PX_Color(pPX,"ChartForeColor",m_chartForeColor,RGB(0,128,0));

	PX_Long(pPX,"UpperRangeLine1",m_upperRangeLine1,100);
	PX_Long(pPX,"UpperRangeLine2",m_upperRangeLine2,100);
	PX_Long(pPX,"UpperRangeLine3",m_upperRangeLine3,100);
	PX_Long(pPX,"UpperRangeLine4",m_upperRangeLine4,100);

	PX_Long(pPX,"LowerRangeLine1",m_lowerRangeLine1,0);
	PX_Long(pPX,"LowerRangeLine2",m_lowerRangeLine2,0);
	PX_Long(pPX,"LowerRangeLine3",m_lowerRangeLine3,0);
	PX_Long(pPX,"LowerRangeLine4",m_lowerRangeLine4,0);




}


/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl::OnResetState - Reset control to default state

void CChartl32Ctrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl::AboutBox - Display an "About" box to the user

void CChartl32Ctrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_CHARTL32);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl message handlers

void CChartl32Ctrl::OnChartBackColorChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
	InvalidateControl();
}

void CChartl32Ctrl::OnChartForeColorChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
	InvalidateControl();
}

void CChartl32Ctrl::OnLine1ColorChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnLine2ColorChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnLine3ColorChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnLine4ColorChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::Draw() 
{
	// TODO: Add your dispatch handler code here
	DrawSpike();
	InvalidateControl();
	

}

void CChartl32Ctrl::DrawSpike()
{



	CRect rcClient;

	rcClient.CopyRect(m_rectChart); 

	if (m_memDC->GetSafeHdc() != NULL) { 

		m_memDC->BitBlt(0,0,rcClient.Width() ,rcClient.Height() ,m_memDC,4,0,SRCCOPY);
		

		// Draw Scale
		CRect rcRight = rcClient;
		rcRight.left = rcRight.right -4;
		m_memDC->SetBkColor(TranslateColor(m_chartBackColor));
		
		CBrush bkBrush(HS_HORIZONTAL,TranslateColor(m_chartForeColor));
		m_memDC->FillRect(rcRight,&bkBrush);
		
		
		m_bDrawVerticle = !m_bDrawVerticle;

		if (m_bDrawVerticle) {

			CPen pen(PS_SOLID,1,TranslateColor(m_chartForeColor));
			CPen* pOldPen = m_memDC->SelectObject(&pen);
			m_memDC->MoveTo(CPoint(rcClient.right -2,rcClient.top));
			m_memDC->LineTo(CPoint(rcClient.right -2,rcClient.bottom));
			m_memDC->SelectObject(pOldPen); 


		}

		// Draw Line
		int nCount = m_items.GetSize();
		CLineChartItem* pItem;
		CPoint ptOld, ptNew;
		for (int i=0; i<nCount; i++)
		{
			pItem = m_items.GetAt(i);

			UINT  nRange = pItem->m_nUpper - pItem->m_nLower;
	
			ptOld.x = rcRight.left-1; 
			ptNew.x = rcRight.right-1;
				

			ptOld.y = (int)((((float)(nRange - (pItem->m_nOldPos-pItem->m_nLower)))/(float)nRange)
				* (float)rcRight.Height());

			ptNew.y = (int)((((float)(nRange - (pItem->m_nPos-pItem->m_nLower)))/(float)nRange)
				* (float)rcRight.Height());

			CPen pen(PS_SOLID, 1, pItem->m_colorLine);
			CPen* pOldPen = m_memDC->SelectObject(&pen);
			m_memDC->MoveTo(ptOld);
			m_memDC->LineTo(ptNew);
			m_memDC->SelectObject(pOldPen);
		}	

	}



}

void CChartl32Ctrl::RemoveObjectLine()
{

	int nCount = m_items.GetSize();
	for (int i = 0; i < nCount; i++)
		delete m_items.GetAt(i);
	m_items.RemoveAll();

}

BOOL CChartl32Ctrl::Add(COLORREF color, int Upper, int Lower)
{

	CLineChartItem* pItem = new CLineChartItem;
	pItem->m_colorLine = color;
	pItem->m_nLower = Lower;
	pItem->m_nUpper = Upper;
	pItem->m_nPos = Lower;
	pItem->m_nOldPos = Lower;

	try 
	{
		m_items.Add(pItem);

		
		return TRUE;
	}
	catch (CMemoryException* e)
	{
		if (pItem !=NULL) 
			delete pItem;
		e->Delete();
		return FALSE;
	}



}

void CChartl32Ctrl::PlotLine(short NumLine, long Value) 
{
	// TODO: Add your dispatch handler code here

	
	if ((NumLine <= 0) || (NumLine > 4))
		return;

	NumLine--;

	if (m_items.GetSize() <=0) { 
		Add(TranslateColor(m_line1Color),m_upperRangeLine1,m_lowerRangeLine1);
		Add(TranslateColor(m_line2Color),m_upperRangeLine2,m_lowerRangeLine2);
		Add(TranslateColor(m_line3Color),m_upperRangeLine3,m_lowerRangeLine3);
		Add(TranslateColor(m_line4Color),m_upperRangeLine4,m_lowerRangeLine4);	
	}



	if (NumLine>= m_items.GetSize())
		return ;

	CLineChartItem* pItem = m_items.GetAt(NumLine);

	if (Value > pItem->m_nUpper)
		Value = pItem->m_nUpper;
	if (Value < pItem->m_nLower)
		Value = pItem->m_nLower;

	pItem->m_nOldPos = pItem->m_nPos;
	pItem->m_nPos = Value;



}

void CChartl32Ctrl::OnUpperRangeLine1Changed() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnUpperRangeLine2Changed() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnUpperRangeLine3Changed() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnUpperRangeLine4Changed() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnLowerRangeLine1Changed() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnLowerRangeLine2Changed() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnLowerRangeLine3Changed() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnLowerRangeLine4Changed() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CChartl32Ctrl::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	COleControl::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	
}

void CChartl32Ctrl::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	COleControl::OnTimer(nIDEvent);
}

void CChartl32Ctrl::ChangeLineColor(short Line, long Color) 
{
	// TODO: Add your dispatch handler code here

	if ((Line <= 0) || (Line > 4))
		return;

	Line--;
	if (Line>= m_items.GetSize())
		return ;

	CLineChartItem* pItem = m_items.GetAt(Line);
	pItem->m_colorLine = COLORREF(Color);
	


}

void CChartl32Ctrl::ChangeLineRange(short Line, long Lower, long Upper) 
{
	// TODO: Add your dispatch handler code here


	if ((Line <= 0) || (Line > 4))
		return;

	Line--;
	
	if (Line>= m_items.GetSize())
		return ;

	if (Lower >= Upper)
		return;


	CLineChartItem* pItem = m_items.GetAt(Line);

	pItem->m_nUpper = Upper;
	pItem->m_nLower = Lower;
	pItem->m_nPos = Lower;
	pItem->m_nOldPos = Lower;


}
