#if !defined(AFX_CHARTL32CTL_H__6FE0740B_AB0F_11D4_AA39_00C04F8A5E89__INCLUDED_)
#define AFX_CHARTL32CTL_H__6FE0740B_AB0F_11D4_AA39_00C04F8A5E89__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Chartl32Ctl.h : Declaration of the CChartl32Ctrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CChartl32Ctrl : See Chartl32Ctl.cpp for implementation.


#include <afxtempl.h>

class CLineChartItem:public CObject
{
public:
	CLineChartItem() {;}

	COLORREF m_colorLine;
	int     m_nLower;		// lower bounds
	int     m_nUpper;		// upper bounds
	
	int     m_nPos;		// current position within bounds
	int     m_nOldPos;		// last position within bounds
};

typedef CTypedPtrArray <CObArray, CLineChartItem*> CItemArray;



class CChartl32Ctrl : public COleControl
{
	DECLARE_DYNCREATE(CChartl32Ctrl)

// Constructor
public:
	CChartl32Ctrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChartl32Ctrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL Add(COLORREF color, int Upper, int Lower);
	void RemoveObjectLine();
	CDC* m_memDC;
	CBitmap* m_pBitmap;
	CSize	m_sizeChart;	
	CRect	m_rectChart;
	BOOL m_bDrawVerticle;
	OLE_COLOR m_colorback;
	OLE_COLOR m_colorfore;
	CItemArray m_items;

	
	

	~CChartl32Ctrl();

	DECLARE_OLECREATE_EX(CChartl32Ctrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CChartl32Ctrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CChartl32Ctrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CChartl32Ctrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CChartl32Ctrl)
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CChartl32Ctrl)
	OLE_COLOR m_chartBackColor;
	afx_msg void OnChartBackColorChanged();
	OLE_COLOR m_chartForeColor;
	afx_msg void OnChartForeColorChanged();
	OLE_COLOR m_line1Color;
	afx_msg void OnLine1ColorChanged();
	OLE_COLOR m_line2Color;
	afx_msg void OnLine2ColorChanged();
	OLE_COLOR m_line3Color;
	afx_msg void OnLine3ColorChanged();
	OLE_COLOR m_line4Color;
	afx_msg void OnLine4ColorChanged();
	long m_upperRangeLine1;
	afx_msg void OnUpperRangeLine1Changed();
	long m_upperRangeLine2;
	afx_msg void OnUpperRangeLine2Changed();
	long m_upperRangeLine3;
	afx_msg void OnUpperRangeLine3Changed();
	long m_upperRangeLine4;
	afx_msg void OnUpperRangeLine4Changed();
	long m_lowerRangeLine1;
	afx_msg void OnLowerRangeLine1Changed();
	long m_lowerRangeLine2;
	afx_msg void OnLowerRangeLine2Changed();
	long m_lowerRangeLine3;
	afx_msg void OnLowerRangeLine3Changed();
	long m_lowerRangeLine4;
	afx_msg void OnLowerRangeLine4Changed();
	afx_msg void Draw();
	afx_msg void PlotLine(short NumLine, long Value);
	afx_msg void ChangeLineColor(short Line, long Color);
	afx_msg void ChangeLineRange(short Line, long Lower, long Upper);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CChartl32Ctrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	void DrawSpike();
	enum {
	//{{AFX_DISP_ID(CChartl32Ctrl)
	dispidChartBackColor = 1L,
	dispidChartForeColor = 2L,
	dispidLine1Color = 3L,
	dispidLine2Color = 4L,
	dispidLine3Color = 5L,
	dispidLine4Color = 6L,
	dispidUpperRangeLine1 = 7L,
	dispidUpperRangeLine2 = 8L,
	dispidUpperRangeLine3 = 9L,
	dispidUpperRangeLine4 = 10L,
	dispidLowerRangeLine1 = 11L,
	dispidLowerRangeLine2 = 12L,
	dispidLowerRangeLine3 = 13L,
	dispidLowerRangeLine4 = 14L,
	dispidDraw = 15L,
	dispidPlotLine = 16L,
	dispidChangeLineColor = 17L,
	dispidChangeLineRange = 18L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHARTL32CTL_H__6FE0740B_AB0F_11D4_AA39_00C04F8A5E89__INCLUDED)
